﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace project_28_7b {
    class Program {
        class SchoolMember {
            private string name;
            private int age;

            //Define the constructor
            public SchoolMember(string name, int age) {
                Name = name;
                Age = age;
                Console.WriteLine("A school member was initialized");
            }

            //Define the property Name
            public string Name {
                get {
                    return name;
                }
                set {
                    if (value != "") {
                        name = value;
                    }
                    else {
                        throw new Exception("Name cannot be empty");
                    }
                }
            }

            //Define the property Age
            public int Age {
                get {
                    return age;
                }
                set {
                    if (value > 0) {
                        age = value;
                    }
                    else {
                        throw new Exception("Age cannot be negative or zero");
                    }
                }
            }
        }

        class Teacher : SchoolMember {
            private double salary; //This is a specific field for class Teacher

            //Define the constructor
            public Teacher(string name, int age, double salary) : base(name, age) {
                Salary = salary;
                Console.WriteLine("A teacher was initialized");
            }

            //Define the property Salary
            public double Salary {
                get {
                    return salary;
                }
                set {
                    if (value >= 0) {
                        salary = value;
                    }
                    else {
                        throw new Exception("Salary cannot be negative");
                    }
                }
            }
        }

        class Student : SchoolMember {
            private int[] grades = new int[3]; //This is a specific field for class Student

            //Define the constructor
            public Student(string name, int age, int[] grades) : base(name, age) {
                Grades = grades;
                Console.WriteLine("A student was initialized");
            }

            //Define the property Grades
            public int[] Grades {
                get {
                    return grades;
                }
                set {
                    bool negative_found;
                    negative_found = false;
                    foreach (var g in value) {
                        if (g < 0) {
                            negative_found = true;
                        }
                    }
                    if (negative_found == false) {
                        grades = value;
                    }
                    else {
                        throw new Exception("Grades cannot be negative");
                    }
                }
            }
        }

        //Main code starts here
        static void Main() {
            Teacher teacher1 = new Teacher("Mr. John Scott", 43, 35000);
            Teacher teacher2 = new Teacher("Mrs. Ann Carter", 5, 32000);

            Student student1 = new Student("Peter Nelson", 14, new int[] { 90, 95, 92 });
            Student student2 = new Student("Helen Morgan", 13, new int[] { 92, 97, 94 });

            Console.WriteLine(teacher1.Name);
            Console.WriteLine(teacher1.Age);
            Console.WriteLine(teacher1.Salary);

            Console.WriteLine(student2.Name);
            Console.WriteLine(student2.Age);
            foreach (var grade in student2.Grades) {
                Console.WriteLine(grade);
            }

            Console.ReadKey();
        }
    }
}
